package sun.security.tools.policytool;

import sun.security.provider.PolicyParser;
import java.lang.reflect.InvocationTargetException;
import java.text.MessageFormat;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class NewPolicyPermOKButtonListener implements ActionListener
{
    private PolicyTool tool;
    private ToolWindow tw;
    private ToolDialog listDialog;
    private ToolDialog infoDialog;
    private boolean edit;
    
    NewPolicyPermOKButtonListener(PolicyTool tool, ToolWindow tw, ToolDialog listDialog, ToolDialog infoDialog, boolean edit) {
        this.tool = tool;
        this.tw = tw;
        this.listDialog = listDialog;
        this.infoDialog = infoDialog;
        this.edit = edit;
    }
    
    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        try {
            PolicyParser.PermissionEntry permFromDialog = this.infoDialog.getPermFromDialog();
            try {
                this.tool.verifyPermission(permFromDialog.permission, permFromDialog.name, permFromDialog.action);
            }
            catch (ClassNotFoundException ex) {
                MessageFormat messageFormat = new MessageFormat(PolicyTool.getMessage("Warning.Class.not.found.class"));
                Object[] array = { permFromDialog.permission };
                this.tool.warnings.addElement(messageFormat.format(array));
                this.tw.displayStatusDialog(this.infoDialog, messageFormat.format(array));
            }
            TaggedList list = (TaggedList)this.listDialog.getComponent(8);
            String permissionEntryToUserFriendlyString = ToolDialog.PermissionEntryToUserFriendlyString(permFromDialog);
            if (this.edit) {
                list.replaceTaggedItem(permissionEntryToUserFriendlyString, permFromDialog, list.getSelectedIndex());
            }
            else {
                list.addTaggedItem(permissionEntryToUserFriendlyString, permFromDialog);
            }
            this.infoDialog.dispose();
        }
        catch (InvocationTargetException ex2) {
            this.tw.displayErrorDialog(this.infoDialog, ex2.getTargetException());
        }
        catch (Exception ex3) {
            this.tw.displayErrorDialog(this.infoDialog, ex3);
        }
    }
}
